//--------------------------------------------------------------------------------------
//  Plik naglwkowy I2O1W3
//  Autor: Piotr M. Szczypinski
//  Instytut Elektroniki Politechniki Ldzkiej
//--------------------------------------------------------------------------------------

#include "vtwoinp.h"

// Deklaracja klasy filtru
class KlasaFiltru_I2O1W3 : public CTwoOneFiltr //!!! wczesniej CTransInPlaceFilter
	,public CAMThread //!!! teraz dziedziczy rowniez z klasy tworzacej watek roboczy
{
    public:
        static CUnknown * WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);
        DECLARE_IUNKNOWN;
        HRESULT CheckInputType(const CMediaType* mtIn);
		HRESULT ReceiveLeft(IMediaSample *pIn);
		HRESULT ReceiveRight(IMediaSample *pIn);
            
    private:
		int m_Width;
		int m_Height;
        KlasaFiltru_I2O1W3(TCHAR *tszName, LPUNKNOWN punk, HRESULT *phr);
		HRESULT Transform(IMediaSample *pInLeftSample, IMediaSample *pInRightSample, IMediaSample *pOutSample); //!!!

		HANDLE event_WejsciowaGotowa[2];//????
		HANDLE event_ZwolnijProbke[2];//????
		IMediaSample * probka_WejsciowaWstrzymana[2]; //!!! wskaznik probki

		~KlasaFiltru_I2O1W3(); //!!!
	    HRESULT DecideBufferSize(IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProperties); //!!!
		HRESULT GetMediaType(int iPosition, CMediaType *pMediaType); //!!!
		HRESULT CheckTransform(const CMediaType *mtIn,const CMediaType *mtOut); //!!!
		DWORD ThreadProc(void); //!!! funkcja watku roboczego
};
